Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class FilteredTermsEnum

    java.lang.Object
      org.apache.lucene.index.TermsEnum
          org.apache.lucene.index.FilteredTermsEnum

All Implemented Interfaces:
  BytesRefIterator

Direct Known Subclasses:
  PrefixTermsEnum, SingleTermsEnum, TermRangeTermsEnum

    public abstract class FilteredTermsEnum

extends TermsEnum

Abstract class for enumerating a subset of all terms.

Term enumerations are always ordered by `getComparator()`. Each term in the enumeration is greater than all that precede it.

Please note: Consumers of this enum cannot call `seek()`, it is forward only; it throws `UnsupportedOperationException` when a seeking method is called.

Nested Class Summary
`protected static class` | `FilteredTermsEnum.AcceptStatus` Return value, if term should be accepted or the iteration should `END`.

Nested classes/interfaces inherited from class org.apache.lucene.index.TermsEnum
`TermsEnum.SeekStatus`

Field Summary

Fields inherited from class org.apache.lucene.index.TermsEnum
`EMPTY`

Constructor Summary
`FilteredTermsEnum(TermsEnum tenum)` Creates a filtered `TermsEnum` on a terms enum.
`FilteredTermsEnum(TermsEnum tenum, boolean startWithSeek)` Creates a filtered `TermsEnum` on a terms enum.

Method Summary
`protected abstract FilteredTermsEnum.AcceptStatus` | `accept(BytesRef term)` Return if term is accepted, not accepted or the iteration should ended (and possibly seek).
`AttributeSource` | `attributes()` Returns the related attributes, the returned `AttributeSource` is shared with the delegate `TermsEnum`.
`int` | `docFreq()` Returns the number of documents containing the current term.
`DocsEnum` | `docs(Bits bits, DocsEnum reuse, int flags)` Get `DocsEnum` for the current term, with control over whether freqs are required.
`DocsAndPositionsEnum` | `docsAndPositions(Bits bits, DocsAndPositionsEnum reuse, int flags)` Get `DocsAndPositionsEnum` for the current term, with control over whether offsets and payloads are required.
`Comparator<BytesRef>` | `getComparator()` Return the `BytesRef` Comparator used to sort terms provided by the iterator.
`BytesRef` | `next()` Increments the iteration to the next `BytesRef` in the iterator.
`protected BytesRef` | `nextSeekTerm(BytesRef currentTerm)` On the first call to `next()` or if `accept(org.apache.lucene.util.BytesRef)` returns `FilteredTermsEnum.AcceptStatus.YES_AND_SEEK` or `FilteredTermsEnum.AcceptStatus.NO_AND_SEEK`, this method will be called to eventually seek the underlying TermsEnum to a new position.
`long` | `ord()` Returns ordinal position for current term.
`TermsEnum.SeekStatus` | `seekCeil(BytesRef term, boolean useCache)` This enum does not support seeking!
`boolean` | `seekExact(BytesRef term, boolean useCache)` This enum does not support seeking!
`void` | `seekExact(BytesRef term, TermState state)` This enum does not support seeking!
`void` | `seekExact(long ord)` This enum does not support seeking!
`protected void` | `setInitialSeekTerm(BytesRef term)` Use this method to set the initial `BytesRef` to seek before iterating.
`BytesRef` | `term()` Returns current term.
`TermState` | `termState()` Returns the filtered enums term state
`long` | `totalTermFreq()` Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term).

Methods inherited from class org.apache.lucene.index.TermsEnum
`docs, docsAndPositions, seekCeil`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FilteredTermsEnum

    public FilteredTermsEnum(TermsEnum tenum)

  Creates a filtered `TermsEnum` on a terms enum.

  Parameters:
    `tenum` - the terms enumeration to filter.

### FilteredTermsEnum

    public FilteredTermsEnum(TermsEnum tenum,
                             boolean startWithSeek)

  Creates a filtered `TermsEnum` on a terms enum.

  Parameters:
    `tenum` - the terms enumeration to filter.

Method Detail

### accept

    protected abstract FilteredTermsEnum.AcceptStatus accept(BytesRef term)
                                                      throws IOException

  Return if term is accepted, not accepted or the iteration should ended (and possibly seek).

  Throws:
    `IOException`

### setInitialSeekTerm

    protected final void setInitialSeekTerm(BytesRef term)

  Use this method to set the initial `BytesRef` to seek before iterating. This is a convenience method for subclasses that do not override `nextSeekTerm(org.apache.lucene.util.BytesRef)`. If the initial seek term is `null` (default), the enum is empty.

  You can only use this method, if you keep the default implementation of `nextSeekTerm(org.apache.lucene.util.BytesRef)`.

### nextSeekTerm

    protected BytesRef nextSeekTerm(BytesRef currentTerm)
                             throws IOException

  On the first call to `next()` or if `accept(org.apache.lucene.util.BytesRef)` returns `FilteredTermsEnum.AcceptStatus.YES_AND_SEEK` or `FilteredTermsEnum.AcceptStatus.NO_AND_SEEK`, this method will be called to eventually seek the underlying TermsEnum to a new position. On the first call, `currentTerm` will be `null`, later calls will provide the term the underlying enum is positioned at. This method returns per default only one time the initial seek term and then `null`, so no repositioning is ever done.

  Override this method, if you want a more sophisticated TermsEnum, that repositions the iterator during enumeration. If this method always returns `null` the enum is empty.

  Please note: This method should always provide a greater term than the last enumerated term, else the behaviour of this enum violates the contract for TermsEnums.

  Throws:
    `IOException`

### attributes

    public AttributeSource attributes()

  Returns the related attributes, the returned `AttributeSource` is shared with the delegate `TermsEnum`.

  Overrides:
    `attributes` in class `TermsEnum`

### term

    public BytesRef term()
                  throws IOException

  Description copied from class: `TermsEnum`
  Returns current term. Do not call this when the enum is unpositioned.

  Specified by:
    `term` in class `TermsEnum`
  Throws:
    `IOException`

### getComparator

    public Comparator<BytesRef> getComparator()

  Description copied from interface: `BytesRefIterator`
  Return the `BytesRef` Comparator used to sort terms provided by the iterator. This may return null if there are no items or the iterator is not sorted. Callers may invoke this method many times, so it's best to cache a single instance & reuse it.

### docFreq

    public int docFreq()
                throws IOException

  Description copied from class: `TermsEnum`
  Returns the number of documents containing the current term. Do not call this when the enum is unpositioned. `TermsEnum.SeekStatus.END`.

  Specified by:
    `docFreq` in class `TermsEnum`
  Throws:
    `IOException`

### totalTermFreq

    public long totalTermFreq()
                       throws IOException

  Description copied from class: `TermsEnum`
  Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term). This will be -1 if the codec doesn't support this measure. Note that, like other term measures, this measure does not take deleted documents into account.

  Specified by:
    `totalTermFreq` in class `TermsEnum`
  Throws:
    `IOException`

### seekExact

    public boolean seekExact(BytesRef term,
                             boolean useCache)
                      throws IOException

  This enum does not support seeking!

  Overrides:
    `seekExact` in class `TermsEnum`
  Throws:
    `UnsupportedOperationException` - In general, subclasses do not support seeking.
    `IOException`

### seekCeil

    public TermsEnum.SeekStatus seekCeil(BytesRef term,
                                         boolean useCache)
                                  throws IOException

  This enum does not support seeking!

  Specified by:
    `seekCeil` in class `TermsEnum`
  Throws:
    `UnsupportedOperationException` - In general, subclasses do not support seeking.
    `IOException`

### seekExact

    public void seekExact(long ord)
                   throws IOException

  This enum does not support seeking!

  Specified by:
    `seekExact` in class `TermsEnum`
  Throws:
    `UnsupportedOperationException` - In general, subclasses do not support seeking.
    `IOException`

### ord

    public long ord()
             throws IOException

  Description copied from class: `TermsEnum`
  Returns ordinal position for current term. This is an optional method (the codec may throw `UnsupportedOperationException`). Do not call this when the enum is unpositioned.

  Specified by:
    `ord` in class `TermsEnum`
  Throws:
    `IOException`

### docs

    public DocsEnum docs(Bits bits,
                         DocsEnum reuse,
                         int flags)
                  throws IOException

  Description copied from class: `TermsEnum`
  Get `DocsEnum` for the current term, with control over whether freqs are required. Do not call this when the enum is unpositioned. This method will not return null.

  Specified by:
    `docs` in class `TermsEnum`
  Parameters:
    `bits` - unset bits are documents that should not be returned
    `reuse` - pass a prior DocsEnum for possible reuse
    `flags` - specifies which optional per-document values you require; see `DocsEnum.FLAG_FREQS`
  Throws:
    `IOException`
  See Also:
    `TermsEnum.docs(Bits, DocsEnum, int)`

### docsAndPositions

    public DocsAndPositionsEnum docsAndPositions(Bits bits,
                                                 DocsAndPositionsEnum reuse,
                                                 int flags)
                                          throws IOException

  Description copied from class: `TermsEnum`
  Get `DocsAndPositionsEnum` for the current term, with control over whether offsets and payloads are required. Some codecs may be able to optimize their implementation when offsets and/or payloads are not required. Do not call this when the enum is unpositioned. This will return null if positions were not indexed.

  Specified by:
    `docsAndPositions` in class `TermsEnum`
  Parameters:
    `bits` - unset bits are documents that should not be returned
    `reuse` - pass a prior DocsAndPositionsEnum for possible reuse
    `flags` - specifies which optional per-position values you require; see `DocsAndPositionsEnum.FLAG_OFFSETS` and `DocsAndPositionsEnum.FLAG_PAYLOADS`.
  Throws:
    `IOException`

### seekExact

    public void seekExact(BytesRef term,
                          TermState state)
                   throws IOException

  This enum does not support seeking!

  Overrides:
    `seekExact` in class `TermsEnum`
  Parameters:
    `term` - the term the TermState corresponds to
    `state` - the `TermState`
  Throws:
    `UnsupportedOperationException` - In general, subclasses do not support seeking.
    `IOException`

### termState

    public TermState termState()
                        throws IOException

  Returns the filtered enums term state

  Overrides:
    `termState` in class `TermsEnum`
  Throws:
    `IOException`
  See Also:
    `TermState`, `TermsEnum.seekExact(BytesRef, TermState)`

### next

    public BytesRef next()
                  throws IOException

  Description copied from interface: `BytesRefIterator`
  Increments the iteration to the next `BytesRef` in the iterator. Returns the resulting `BytesRef` or `null` if the end of the iterator is reached. The returned BytesRef may be re-used across calls to next. After this method returns null, do not call it again: the results are undefined.

  Returns:
    the next `BytesRef` in the iterator or `null` if the end of the iterator is reached.
  Throws:
    `IOException` - If there is a low-level I/O error.

Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.